package cn.ey.biz.module.system.api.rate;

import cn.ey.biz.common.pojo.R;
import cn.ey.biz.module.system.api.rate.dto.*;
import cn.ey.biz.module.system.service.rate.DictGdsRateService;
import cn.ey.biz.module.system.service.rate.FinanceRateService;
import org.apache.dubbo.config.annotation.DubboService;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

import java.util.List;

import static cn.ey.biz.module.system.enums.ApiConstants.VERSION;

@RestController // 提供 RESTful API 接口，给 Feign 调用
@DubboService(version = VERSION) // 提供 Dubbo RPC 接口，给 Dubbo Consumer 调用
@Validated
public class RateApiImpl implements RateApi {

    @Resource
    private FinanceRateService financeRateService;

    @Resource
    private DictGdsRateService dictGdsRateService;

    @Override
    public R<List<RateResDTO>> getRateForGpn(RateForGpnReqDTO rateForGpnReqDTO) {
        return R.success(financeRateService.getRateForGpn(rateForGpnReqDTO));
    }

    @Override
    public R<List<RateResDTO>> getFirmRateForConfig(RateForFirmConfReqDTO rateForFirmConfReqDTO) {
        return R.success(financeRateService.getFirmRateForConfig(rateForFirmConfReqDTO));
    }

    @Override
    public R<List<RateResDTO>> getGdsRateForConfig(RateForGdsConfReqDTO rateForGdsConfReqDTO) {
        return R.success(financeRateService.getGdsRateForConfig(rateForGdsConfReqDTO));
    }

    @Override
    public R<FeeSharingFactorResDTO> getFeeSharingFactorRate(FeeSharingFactorReqDTO feeSharingFactorReqDTO) {
        return R.success(financeRateService.getFeeSharingFactor(feeSharingFactorReqDTO));
    }

    @Override
    public R<List<RateResDTO>> getRateForDateScope(RateReqDTO rateReqDTO) {
        return R.success(financeRateService.getRateForDateScope(rateReqDTO));
    }

    @Override
    public R<List<GradeLevelResDTO>> getGdsRank(String codeBlock) {
        return R.success(dictGdsRateService.getGdsRank(codeBlock));
    }
}
